               JOB  Add to or subtract from an address, Preserve X1
     UPDX1     EQU  89
     *
     * B    ADDADR    To add a decimal number to an address
     * DSA  size      Address of to-be-added, any number of digits,
     *                sign in low-order digit is considered
     * DSA  upd       Address of to-be-updated
     * Here, SIZE is in low-order 3 characters of CONVXX as ADCON 
     *
               ORG  4297
     ADDADR    SBR  UPDGX1&6           Argument address
               SW   UPDFLG             Positive offset flag
               B    UPD1
     *
     * B    SUBADR    To subtract a decimal number from an address
     * DSA  size      Address of to-be-subtracted, any number of digits,
     *                sign in low-order digit is considered
     * DSA  upd       Address of to-be-updated
     * Here, 16000-SIZE is in low-order 3 characters of CONVXX as ADCON
     *
     SUBADR    SBR  UPDGX1&6           Argument address
               CW   UPDFLG             Negative offset flag
     *
     UPD1      SBR  UPDRTX-1,0&X1      Save X1
     UPDGX1    SBR  UPDX1,0-0          Argument address to X1
               SBR  UPDRTX&3,6&X1      Exit address
               MCW  2&X1,*&4           To-be-converted address to NSIA
               ZA   0-0,CONVXX         To-be-converted to CONVXX
               BW   UPD2,UPDFLG
               ZS   CONVXX             Negate to-be added/subtracted
     UPD2      BWZ  UPD3,CONVXX,B      Augend/Minuend positive?
               A    &16000,CONVXX      No, compute 16000 - offset
     UPD3      MZ   UPDZ,CONVXX        clear zone
     UPDL      S    UPDP1,CONVXX-3     decrement 1000's
               BM   UPDLX,CONVXX-3     Done?
               MA   UPD1K,CONVXX       Add 1000
               B    UPDL
     *
     UPDLX     MCW  5&X1,*&7           To-be-updated address to NSIB
               MA   CONVXX,0-0         Update to-be-updated
               SBR  UPDX1,0-0          Restore X1
     UPDRTX    B    0-0                Return
     CONVXX    DCW  #5
     UPDZ      DCW  0
     UPDP1     DCW  1
     UPD1K     DSA  1000
     UPDFLG    DC   0                  WM = ADDADR, No WM = SUBADR
     *
     test      b    addadr
               dsa  addr
               dsa  206
               mcw  truep,216
               b    subadr
               dsa  addr
               dsa  226
               mcw  truen,236
               b    addadr
               dsa  addrm
               dsa  246
               mcw  truen,256
               b    subadr
               dsa  addrm
               dsa  266
               mcw  truep,276
               w
               h
     addr      dcw  5000
     addrm     dcw  -5000
     truep     dsa  5000
     truen     dsa  11000
               END  test
